﻿# Get-ADUserにてADUserObject Import-Csv形式の情報がパイプで流れてくるので、それを順次処理する
# $inputはパイプを示す予約変数
$input | foreach {
    try {
		# New-ADUserを使って必要なPropertyを設定していく 
		# -PassThru でADUser Objectを拾う -ErrorAction は try-catch に必要
		$res = New-ADUser -name $_.Name -SamAccountName $_.SamAccountName `
			-Surname $_.Surname -GivenName $_.GivenName -DisplayName $_.DisplayName `
			-Path $_.Path `
			-PassThru -ErrorAction stop
			
		# パスワードの設定
		$res | Set-ADAccountPassword -Reset `
			-NewPassword (ConvertTo-SecureString -AsPlainText $_.Password –Force)`
			-ErrorAction stop
			
		# アカウントの有効化
		$res | Enable-ADAccount -ErrorAction stop
		
		"OK"
    }
    catch {
    	$Error[0].ToString()
    }
}
