﻿# 設定は Get-ADUser と Set-ADUser を組み合わせる。
# これはオプションでは対応できないプロパティに対処するためである。
"Set-User.ps1" >> d:\ps.log
(Get-Date).DateTime >> d:\ps.log

$input | foreach {
    try {
		# SamAccountNameをIDとして全プロパティを取得
		$user = Get-ADUser -Identity $_.SamAccountName -Properties * -ErrorAction Stop
		
		# Propertｙの設定…力技だけど無難
		# $user.Name = $_.Name						# Name の変更はRename-ADObject
		$user.DisplayName = $_.DisplayName			# 表示名
		$user.Surname = $_.Surname					# 姓
		$user.GivenName = $_.GivenName				# 名
		$user.Description = $_.Description			# 説明
		$user.Company = $_.Company					# 会社名
		$user.EmployeeNumber = $_.EmployeeNumber	# 社員番号
		$user.Department = $_.Department			# 部署
		$user.Title = $_.Title						# 役職
		$user.HomePhone = $_.HomePhone	
		$user.MobilePhone = $_.MobilePhone
		$user.OfficePhone = $_.OfficePhone
		$user.PostalCode = $_.PostalCode			# 郵便番号
		$user.State = $_.State						# 都道府県
		$user.City = $_.City						# 市町村
		$user.StreetAddress = $_.StreetAddress		# 住所
#		$user.xxx = $_.xxx
#		$user.xxx = $_.xxx
#		$user.xxx = $_.xxx
		
		Set-ADUser -Instanc $user -ErrorAction Stop		
		"OK"
    }
    catch {
    	$Error[0].ToString()
    }
}

(Get-Date).DateTime >> d:\ps.log
